/* gl_stubs.h - Don Yang (uguu.org)

   GLUT function declarations for splint.
                                                                           */

#ifndef GL_STUBS_H__
#define GL_STUBS_H__

/* gl.h */
#define GL_TRIANGLE_FAN          0x0006
#define GL_SRC_ALPHA             0x0302
#define GL_ONE_MINUS_SRC_ALPHA   0x0303
#define GL_BACK                  0x0405
#define GL_TEXTURE_2D            0x0de1
#define GL_BLEND                 0x0be2
#define GL_COMPILE               0x1300
#define GL_UNSIGNED_BYTE         0x1401
#define GL_MODELVIEW             0x1700
#define GL_PROJECTION            0x1701
#define GL_RGBA                  0x1908
#define GL_NEAREST               0x2600
#define GL_LINEAR                0x2601
#define GL_TEXTURE_MAG_FILTER    0x2800
#define GL_TEXTURE_MIN_FILTER    0x2801
#define GL_COLOR_BUFFER_BIT      0x4000

typedef unsigned int GLenum;
typedef unsigned int GLbitfield;
typedef unsigned int GLuint;
typedef int GLint;
typedef int GLsizei;
typedef float GLfloat;
typedef double GLdouble;
typedef void GLvoid;

extern void glClear(GLbitfield);
extern void glEnable(GLenum);
extern void glDisable(GLenum);
extern void glFlush(void);

extern void glDrawBuffer(GLenum);
extern void glViewport(GLint, GLint, GLsizei, GLsizei);
extern void glMatrixMode(GLenum);
extern void glLoadIdentity(void);
extern void glPushMatrix(void);
extern void glPopMatrix(void);

extern GLuint glGenLists(GLsizei);
extern void glDeleteLists(GLuint, GLsizei);
extern void glNewList(GLuint, GLenum);
extern void glEndList(void);
extern void glCallList(GLuint);

extern void glBegin(GLenum);
extern void glEnd(void);
extern void glVertex2d(GLdouble, GLdouble);
extern void glTexCoord2d(GLdouble, GLdouble);

extern void glScaled(GLdouble, GLdouble, GLdouble);
extern void glTranslated(GLdouble, GLdouble, GLdouble);

extern void glBlendFunc(GLenum, GLenum);

extern void glGenTextures(GLsizei, GLuint*);
extern void glDeleteTextures(GLsizei, const GLuint*);
extern void glBindTexture(GLenum, GLuint);
extern void glTexImage2D(GLenum, GLint, GLint, GLsizei, GLsizei,
                         GLint, GLenum, GLenum, const GLvoid*);
extern void glTexParameteri(GLenum, GLenum, GLint);

/* glu.h */
extern void gluOrtho2D(GLdouble, GLdouble, GLdouble, GLdouble);

/* glut.h */
#define GLUT_RGBA          0U
#define GLUT_DOUBLE        2U
#define GLUT_WINDOW_WIDTH  102
#define GLUT_WINDOW_HEIGHT 103

extern void glutInit(int*, char**);
extern void glutMainLoop(void);

extern void glutInitDisplayMode(unsigned int);
extern void glutPostRedisplay(void);
extern void glutSwapBuffers(void);

extern int glutCreateWindow(const char*);
extern void glutDestroyWindow(int);
extern void glutSetWindow(int);
extern void glutSetWindowTitle(const char*);

extern void glutDisplayFunc(void (*)(void));
extern void glutReshapeFunc(void (*)(int, int));
extern void glutKeyboardFunc(void (*)(unsigned char, int, int));
extern void glutIdleFunc(void (*)(void));

extern int glutGet(GLenum);

#endif
